/*
 * generated by Xtext
 */
package org.xtext.example.mydsl.generator

import com.google.inject.Inject
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.IFileSystemAccess
import org.eclipse.xtext.generator.IGenerator
import org.xtext.example.mydsl.myDsl.Model
import org.xtext.example.mydsl.properties.PropertiesProvider
import org.xtext.example.mydsl.myDsl.Greeting
import org.eclipse.emf.ecore.EObject
import org.eclipse.core.resources.ResourcesPlugin
import org.eclipse.core.resources.IFile

/**
 * Generates code from your model files on save.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#TutorialCodeGeneration
 */
class MyDslGenerator implements IGenerator {

	@Inject
	extension PropertiesProvider propertiesProvider
	
	override void doGenerate(Resource resource, IFileSystemAccess fsa) {
		fsa.generateFile('greetings.txt',
			'''
				«FOR greeting : resource.contents.filter(Model).map[greetings].flatten»
					«getText(getIProject(greeting))» «greeting.name»
				«ENDFOR»
			''')
	}
	
	def getIProject(EObject object) {
		val path = object.eResource.URI.toPlatformString(true)
		val file = ResourcesPlugin.workspace?.root?.findMember(path) as IFile
		file?.project
	}
	
}
