package org.xtext.example.mydsl.properties;

import static org.xtext.example.mydsl.MyDslRuntimeModule.PLUGIN_ID;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ProjectScope;
import org.eclipse.core.runtime.preferences.IEclipsePreferences;
import org.osgi.service.prefs.BackingStoreException;

public class Properties {
	public static final String PROPERTY_TEXT = PLUGIN_ID + ".text";
	public static final String PROPERTY_DEFAULT_TEXT = "Hello";
	
	public static String getText(IProject project) {
		IEclipsePreferences node = new ProjectScope(project).getNode(PLUGIN_ID);
		return node.get(PROPERTY_TEXT, PROPERTY_DEFAULT_TEXT);
	}
	
	public static void storeText(IProject project, String text) throws BackingStoreException {
		IEclipsePreferences node = new ProjectScope(project).getNode(PLUGIN_ID);

		node.put(PROPERTY_TEXT, text);
		node.flush();
	}
}
