/**
 * generated by Xtext
 */
package org.xtext.example.mydsl.generator;

import com.google.common.collect.Iterables;
import com.google.inject.Inject;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.xtext.example.mydsl.myDsl.Greeting;
import org.xtext.example.mydsl.myDsl.Model;
import org.xtext.example.mydsl.properties.PropertiesProvider;

/**
 * Generates code from your model files on save.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#TutorialCodeGeneration
 */
@SuppressWarnings("all")
public class MyDslGenerator implements IGenerator {
  @Inject
  @Extension
  private PropertiesProvider propertiesProvider;
  
  public void doGenerate(final Resource resource, final IFileSystemAccess fsa) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<EObject> _contents = resource.getContents();
      Iterable<Model> _filter = Iterables.<Model>filter(_contents, Model.class);
      final Function1<Model,EList<Greeting>> _function = new Function1<Model,EList<Greeting>>() {
          public EList<Greeting> apply(final Model it) {
            EList<Greeting> _greetings = it.getGreetings();
            return _greetings;
          }
        };
      Iterable<EList<Greeting>> _map = IterableExtensions.<Model, EList<Greeting>>map(_filter, _function);
      Iterable<Greeting> _flatten = Iterables.<Greeting>concat(_map);
      for(final Greeting greeting : _flatten) {
        IProject _iProject = this.getIProject(greeting);
        String _text = this.propertiesProvider.getText(_iProject);
        _builder.append(_text, "");
        _builder.append(" ");
        String _name = greeting.getName();
        _builder.append(_name, "");
        _builder.newLineIfNotEmpty();
      }
    }
    fsa.generateFile("greetings.txt", _builder);
  }
  
  public IProject getIProject(final EObject object) {
    IProject _xblockexpression = null;
    {
      Resource _eResource = object.eResource();
      URI _uRI = _eResource.getURI();
      final String path = _uRI.toPlatformString(true);
      IWorkspace _workspace = ResourcesPlugin.getWorkspace();
      IWorkspaceRoot _root = null;
      if (_workspace!=null) {
        _root=_workspace.getRoot();
      }
      IResource _findMember = null;
      if (_root!=null) {
        _findMember=_root.findMember(path);
      }
      final IFile file = ((IFile) _findMember);
      IProject _project = null;
      if (file!=null) {
        _project=file.getProject();
      }
      _xblockexpression = (_project);
    }
    return _xblockexpression;
  }
}
